'use strict';

var ModuleDependency = require('webpack/lib/dependencies/ModuleDependency');
var WebpackMissingModule = require('webpack/lib/dependencies/WebpackMissingModule');

class OpenUI5ViewDependency extends ModuleDependency {
  constructor(request, object, range) {
    super(request);
    this.range = range;
    this.object = object;
  }

  get type() {
    return 'openui5 view';
  }
}

OpenUI5ViewDependency.Template = class OpenUI5ViewDependencyTemplate {
  apply(dep, source, outputOptions, requestShortener) {
    if (!dep.range) return;
    var comment = outputOptions.pathinfo ? `/*! ${requestShortener.shorten(dep.request)} */ ` : '';
    var content = void 0;
    if (dep.module) {
      content = `new (__webpack_require__(${comment}${JSON.stringify(dep.module.id)}))(${dep.object})`;
    } else {
      content = WebpackMissingModule.module(dep.request);
    }
    source.replace(dep.range[0], dep.range[1] - 1, content);
  }
};

module.exports = OpenUI5ViewDependency;