"use strict";

var AsyncDependenciesBlock = require("webpack/lib/AsyncDependenciesBlock");
var AsyncRequireDependency = require("./RequireAsyncDependency");

module.exports = class RequireAsyncDependenciesBlock extends AsyncDependenciesBlock {
  constructor(expr, arrayRange, functionRange, module, loc) {
    super(null, module, loc, null);
    this.expr = expr;
    this.outerRange = expr.range;
    this.arrayRange = arrayRange;
    this.functionRange = functionRange;
    this.range = [arrayRange[0], functionRange[1]];
    var dep = new AsyncRequireDependency(this);
    dep.loc = loc;
    this.addDependency(dep);
  }
};