"use strict";

var NullDependency = require("webpack/lib/dependencies/NullDependency");

class RequireAsyncDependency extends NullDependency {
  constructor(block) {
    super();
    this.block = block;
  }

  get type() {
    return "openui5 require async";
  }
}

RequireAsyncDependency.Template = class AsyncRequireDependencyTemplate {
  apply(dep, source, runtime) {
    var depBlock = dep.block;
    var promise = runtime.blockPromise({
      block: depBlock,
      message: "openui5 require"
    });

    var startBlock = `${promise}.then(function() { `;
    var endBlock = `}).catch(${runtime.onError()})`;
    source.replace(depBlock.outerRange[0], depBlock.arrayRange[0] - 1, startBlock);
    source.insert(depBlock.arrayRange[0] + 0.9, "var __WEBPACK_UI5_REQUIRE_ARRAY__ = ");

    if (depBlock.functionRange) {
      source.replace(depBlock.arrayRange[1], depBlock.functionRange[0] - 1, "; (");

      source.insert(depBlock.functionRange[1], ").apply(null, __WEBPACK_UI5_REQUIRE_ARRAY__);");
      source.replace(depBlock.functionRange[1], depBlock.outerRange[1] - 1, endBlock);
    } else {
      source.insert(depBlock.arrayRange[1], ";");
      source.replace(depBlock.arrayRange[1], depBlock.outerRange[1] - 1, endBlock);
    }
  }
};

module.exports = RequireAsyncDependency;